/*
    Bible Plus A Bible Reader for Blackberry
    Copyright (C) 2010 Yohanes Nugroho

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Yohanes Nugroho (yohanes@gmail.com)
*/

package com.compactbyte.bibleplus.bb;

import net.rim.blackberry.api.browser.Browser;
import net.rim.blackberry.api.browser.BrowserSession;
import net.rim.device.api.ui.component.ButtonField;
import net.rim.device.api.ui.Field;
import net.rim.device.api.ui.FieldChangeListener;

import net.rim.device.api.ui.UiApplication;
import net.rim.device.api.ui.container.MainScreen;

import net.rim.device.api.ui.component.Dialog;
import net.rim.device.api.ui.FieldChangeListener;
import net.rim.device.api.ui.component.LabelField;
import net.rim.device.api.ui.component.RichTextField;
import net.rim.device.api.ui.MenuItem;
import net.rim.device.api.ui.component.Menu;
import net.rim.device.api.ui.container.VerticalFieldManager;
import net.rim.device.api.i18n.*;
import net.rim.device.api.ui.Manager;
import net.rim.device.api.system.Display;
import net.rim.device.api.ui.Font;
import java.io.*;


final class AboutScreen extends MainScreen implements BiblePlusAppResource, FieldChangeListener
{

	LabelField title ;
	RichTextField rf;
	ButtonField donate;
	ButtonField visitpage;

	private static ResourceBundle _resources = ResourceBundle.getBundle(BUNDLE_ID, BUNDLE_NAME);

	BibleModel model;

	public AboutScreen(BibleModel _model)   {
		model = _model;
		title = new LabelField(_resources.getString(APPLICATION_TITLE) , LabelField.ELLIPSIS | LabelField.USE_ALL_WIDTH);
		setTitle(title);

		donate = new ButtonField(_resources.getString(DONATE_BUTTON), ButtonField.CONSUME_CLICK);
		visitpage = new ButtonField(_resources.getString(VISIT_WEBSITE_BUTTON), ButtonField.CONSUME_CLICK);

		StringBuffer sb = new StringBuffer();
		sb.append(_resources.getString(ABOUT_1));
		sb.append("\n");
		sb.append(_resources.getString(ABOUT_2));
		sb.append("\n");

		rf = new RichTextField(sb.toString(), Field.FOCUSABLE|Field.READONLY|Field.USE_ALL_WIDTH|
			Field.USE_ALL_HEIGHT);
		add(rf);

		add(donate);
		add(visitpage);
		donate.setChangeListener(this);
		visitpage.setChangeListener(this);
		donate.setFocus();
	}
	
	public void fieldChanged(Field field, int context) {
		if (field==donate) {
			String url = _resources.getString(DONATE_URL);
			BrowserSession bSession = Browser.getDefaultSession();
			bSession.displayPage(url);						
		}
		if (field == visitpage) {
			String url = _resources.getString(WEBSITE_URL);
			BrowserSession bSession = Browser.getDefaultSession();
			bSession.displayPage(url);				
		}
	}

	protected boolean onSavePrompt() {
		return true;
	}


}
