/*
    Bible Plus A Bible Reader for Blackberry
    Copyright (C) 2010 Yohanes Nugroho

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Yohanes Nugroho (yohanes@gmail.com)
*/

package com.compactbyte.bibleplus.bb;

import com.compactbyte.bibleplus.reader.MyStringTokenizer;
import com.compactbyte.bibleplus.reader.Util;

class BibleFile {
	String name;
	String location;

	boolean equals(BibleFile other) {
		return (other!=null && 
			other.name.equals(name) && 
			other.location.equals(location));
	}

	BibleFile(String _name, String _location) {
		name = _name;
		location = _location;
	}

	String getLocation() {
		return location;
	}

	public String toString() {
		return name;
	}

	static BibleFile fromStringRepresentation(String s) {
		MyStringTokenizer myst = new MyStringTokenizer(s, ":");
		if (myst.countTokens()!=2) 
			return null;
		String name = Util.unescape(myst.nextToken(), '%');
		String location = Util.unescape(myst.nextToken(), '%');
		return new BibleFile(name, location);
	}

	String toStringRepresentation() {
		String _name = Util.escape(name, '%', ":");		
		String _location = Util.escape(location, '%', ":");
		return _name + ":" + _location;
	}
}
