/*
    Bible Plus A Bible Reader for Blackberry
    Copyright (C) 2010 Yohanes Nugroho

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Yohanes Nugroho (yohanes@gmail.com)
*/

package com.compactbyte.bibleplus.bb;

import net.rim.device.api.ui.UiApplication;
import net.rim.device.api.ui.container.MainScreen;
import net.rim.device.api.ui.Field;
import net.rim.device.api.ui.component.Dialog;
import net.rim.device.api.ui.component.LabelField;
import net.rim.device.api.ui.component.RichTextField;
import net.rim.device.api.ui.MenuItem;
import net.rim.device.api.ui.component.Menu;
import net.rim.device.api.i18n.*;

final class BibleView extends RichTextField {

	final static int NEXT_CHAPTER = 1;
	final static int PREV_CHAPTER = 2;

	public BibleView(String text, long style) {
		super(text, style);
	}

	protected boolean navigationMovement(int dx,
					     int dy,
					     int status,
					     int time) {
		if (!isSelecting()) {
			if (dy>0) {
				if (getCursorPosition()==getTextLength()) {
					fieldChangeNotify(NEXT_CHAPTER);
					return true;
				}
			}
			if (dy<0) {
				if (getCursorPosition()==0) {
					fieldChangeNotify(PREV_CHAPTER);
					return true;
				}
			}
		}

		return super.navigationMovement(dx, dy, status, time);
	}

	public boolean isDirty() {
		return false;
	}


	protected boolean keyChar(char character,
				  int status,
				  int time) {

		if (character==' ') {
			if (getCursorPosition()==getTextLength()) {
				fieldChangeNotify(NEXT_CHAPTER);
				return true;
			}
		}

		return super.keyChar(character, status, time);
	}


	protected void moveFocus(int x,
				 int y,
				 int status,
				 int time){
		//ModelSpecific.log("move focus: " + x + " " + y );
		super.moveFocus(x, y, status, time);
	}

}