/*
    Bible Plus A Bible Reader for Blackberry
    Copyright (C) 2010 Yohanes Nugroho

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Yohanes Nugroho (yohanes@gmail.com)
*/

package com.compactbyte.bibleplus.bb;

import java.io.*;
import javax.microedition.io.file.*;
import javax.microedition.io.Connector;
import com.compactbyte.bibleplus.reader.PDBDataStream;

class FCStream extends PDBDataStream {

	FileConnection fis;
	InputStream is;
	int pos;

	public int getCurrentPosition() {
		return pos;
	}
	
	String filename;

	FCStream(String _filename) throws IOException  {
		ModelSpecific.log("opening  " + filename);
		filename = _filename;
		fis = (FileConnection)Connector.open(filename);
		is = fis.openInputStream();
		pos = 0;
	}
	
	public void read(byte[]data) throws IOException {
		//ModelSpecific.log("Read LEngth " + data.length);
		is.read(data);
		pos += data.length;
	}

	public void seek(int position)  throws IOException {
		//ModelSpecific.log("SEEK TO POSITION " + position);
		is.skip(position-pos);
		pos = position;
	}

	public void skip(int nbytes)  throws IOException {
		//ModelSpecific.log("SKIP  " + nbytes);
		seek(pos + nbytes);
	}

	public boolean canSeek() {
		return false;
	}

	public void close() throws IOException {
		ModelSpecific.log("closing  " + filename);
		is.close();
		fis.close();
	}

	public long getSize() throws IOException {
		return fis.fileSize();
	}

	public String getPathName() {
		return filename;
	}
}
