/*
    Bible Plus A Bible Reader for Blackberry
    Copyright (C) 2010 Yohanes Nugroho

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Yohanes Nugroho (yohanes@gmail.com)
*/

package com.compactbyte.bibleplus.bb;

import net.rim.device.api.ui.UiApplication;
import net.rim.device.api.ui.container.MainScreen;
import net.rim.device.api.ui.Field;
import net.rim.device.api.ui.component.Dialog;
import net.rim.device.api.ui.FieldChangeListener;
import net.rim.device.api.ui.component.ButtonField;
import net.rim.device.api.ui.component.LabelField;
import net.rim.device.api.ui.component.EditField;
import net.rim.device.api.ui.MenuItem;
import net.rim.device.api.ui.container.PopupScreen;
import net.rim.device.api.ui.container.VerticalFieldManager;
import net.rim.device.api.ui.component.Menu;
import net.rim.device.api.i18n.*;
import net.rim.device.api.system.Characters;


final class GotoVerseScreen extends PopupScreen implements BiblePlusAppResource, FieldChangeListener {
	private LabelField gotoexample;
	private EditField verseField;
	private ButtonField gotoButton;

	private static ResourceBundle _resources = ResourceBundle.getBundle(BUNDLE_ID, BUNDLE_NAME);

	String text = "";

	public GotoVerseScreen() {
		super(new VerticalFieldManager());
		
		gotoexample = new LabelField(_resources.getString(GOTO_EXAMPLE) , LabelField.ELLIPSIS | LabelField.USE_ALL_WIDTH);
		add(gotoexample);
		
		verseField = new EditField(_resources.getString(GOTO_LABEL), "", 140, EditField.NO_NEWLINE);
		add(verseField);
		gotoButton = new ButtonField(_resources.getString(GOTO_BUTTON), 
					     ButtonField.CONSUME_CLICK | Field.FIELD_HCENTER);
		gotoButton.setChangeListener(this);
		add(gotoButton);
	}


	/**
	 * Overrides default.  Enter key will take action on directory/file.
	 * Escape key will go up one directory or close application if at top level.
	 *
	 * @see net.rim.device.api.ui.Screen#keyChar(char,int,int)
	 *
	 */
	public boolean keyChar(char c, int status, int time)    {
		switch (c)
		{
		case Characters.ENTER:
			text =  verseField.getText();
			close();
			return true;
		case Characters.ESCAPE:
			close();
			return true;

		default:
			return super.keyChar(c, status, time);
		}
	}

	
	String getText() {
		return text;
	}

	public void fieldChanged(Field field, int context) {
		if (field == gotoButton) {
			text =  verseField.getText();
			close();
		}
	}	

}
