/*
    Bible Plus A Bible Reader for Blackberry
    Copyright (C) 2010 Yohanes Nugroho

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Yohanes Nugroho (yohanes@gmail.com)
*/

package com.compactbyte.bibleplus.bb;

import com.compactbyte.bibleplus.reader.PDBDataStream;
import java.io.*;
import javax.microedition.io.file.*;
import javax.microedition.io.Connector;

import java.io.*;

/**
 * Model specific things that can be separated in a method should go here
 *
 */

class ModelSpecific {

	private static boolean DEBUG = false;

	public static PDBDataStream openDataStream(String path) throws IOException {

		FCRandomStream fcs = new FCRandomStream(path);
		return fcs;
	}


	public static String getConfigStoragePath() {
		String basepath = "file:///store/home/user/documents/bibleplus/";
		try {

			FileConnection fconn = (FileConnection)Connector.open(basepath);	  
			if (!fconn.exists()) {
				fconn.mkdir();
			}
			fconn.close();
			return basepath;
		} catch (IOException e) {
			ModelSpecific.log("Error " + e.getMessage());
			return "";
		}
	}


	public static void log(String message) {
		if (!DEBUG) return;
		String path = "file:///SDCard/log.txt";
		try {

			FileConnection fconn = (FileConnection)Connector.open(path); 
			if (!fconn.exists()) {
				fconn.create();
			}
			OutputStream os = fconn.openOutputStream(fconn.fileSize());
			PrintStream ps = new PrintStream(os);
			ps.println(message);			
			ps.flush();
			ps.close();
			os.close();
			fconn.close();
		} catch (IOException e) {
			
		}		
	}
	
	public static void benchmark(String message, long start) {
		if (!DEBUG) return;
		long end = System.currentTimeMillis();
		ModelSpecific.log("TIME: " + message + " - " + ((end-start)/1000.0));
	}

}

