/*
    Bible Plus A Bible Reader for Blackberry
    Copyright (C) 2010 Yohanes Nugroho

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Yohanes Nugroho (yohanes@gmail.com)
*/

package com.compactbyte.bibleplus.bb;
import net.rim.device.api.ui.container.PopupScreen;
import net.rim.device.api.ui.container.DialogFieldManager;
import net.rim.device.api.ui.component.LabelField;
import net.rim.device.api.ui.Field;
import net.rim.device.api.ui.UiApplication;
import net.rim.device.api.ui.container.MainScreen;

/**
 * Creates a popup dialog box containing a gauge field , displays the 
 * progress as the list is populated because it might take a while.
 */    
class WaitMessageDialog 
{
	private DialogFieldManager _manager;
	private PopupScreen _popupScreen;
	private LabelField _lbfield;
        String message;
        
	/**
	 * Constructor
	 * 
	 * @param title      Text to display on _popupScreen.
	 * @param max        Maximum value of the range _gaugeField can display.
	 */
	public WaitMessageDialog(String title )	{
		_manager = new DialogFieldManager();
		_popupScreen = new PopupScreen(_manager);
		_lbfield = new LabelField(title , Field.USE_ALL_WIDTH);
		_manager.addCustomField(_lbfield);
	}

	public void setMessage(String msg) {
		message = msg;
		UiApplication.getUiApplication().invokeLater(new Runnable() {
				public void run() 	{								
					_lbfield.setText(message);
				}		
			});
	}
                
	public void close() 	{
		// Remove _popupScreen from the stack.
		UiApplication.getUiApplication().invokeLater(new Runnable() {
				public void run() 	{								
					UiApplication.getUiApplication().popScreen(_popupScreen) ; 
				}
			});        
	}

	public void show() {
		UiApplication.getUiApplication().invokeLater(new Runnable() {
				public void run() {			
					ModelSpecific.log("invoke show");
					UiApplication.getUiApplication().pushScreen(_popupScreen);  

				}
			});
	}
}
