/*
    Bible Plus A Bible Reader for Blackberry
    Copyright (C) 2010 Yohanes Nugroho

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Yohanes Nugroho (yohanes@gmail.com)
*/

package com.compactbyte.bibleplus.reader;

final public class BookRange {
       

	final static int RANGE_SEQUENTIAL = 0;
	final static int RANGE_LIST = 1;

	int type;
	String name;
	int index_start;
	int index_end;

	int start_chapter;
	int start_verse;

	int [] list;

	BookRange(int[] _list) {
		index_start = 0;
		index_end = _list.length;
		list = _list;
	}

	int getBookAt(int i) {
		return list[i];
	}

	boolean isSequential() {
		return type==RANGE_SEQUENTIAL;
	}
	
	BookRange(int _index_start,
		  int _index_end ) {
		type = RANGE_SEQUENTIAL;
		index_start = _index_start;
		index_end = _index_end;
		start_chapter = 1;
		start_verse = 1;
	}

	int getStartVerse() {
		return start_verse;
	}

	int getStartChapter() {
		return start_chapter;
	}

	public String toString() {
		return name;
	}

	public void setName(String _name) {
		name = _name;
	}

	public void setStart(int _start, int _chapter, int _verse) {
		index_start = _start;
		start_chapter = _chapter;
		start_verse = _verse;
	}

	public int getBookIndexStart() {
		return index_start;
	}

	public int getBookIndexEnd() {
		return index_end;
	}

}
