/*
    Bible Plus A Bible Reader for Blackberry
    Copyright (C) 2010 Yohanes Nugroho

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Yohanes Nugroho (yohanes@gmail.com)
*/

package com.compactbyte.bibleplus.reader;

import java.io.IOException;

public abstract class PDBDataStream {

	public abstract int getCurrentPosition();
	public abstract void read(byte[]data) throws IOException;
	public abstract void skip(int nbytes)  throws IOException;	
	/**
	 * if canSeek is false, it should be able to seek forward using skip
	 */
	public  void seek(int position)  throws IOException {
		int cpos = getCurrentPosition();
		skip(position-cpos);
	}
	/**
	 * can seek backward/forward
	 */
	public  abstract boolean canSeek();
	public  abstract void close()  throws IOException;
	public  abstract long getSize() throws IOException;

	public abstract String getPathName();
}
