package com.compactbyte.bibleplus.test;

import java.io.*;
import java.util.StringTokenizer;
import com.compactbyte.bibleplus.reader.*;
import java.util.Vector;

class Test {

	static boolean validInteger(String s) {
		try {
			Integer.parseInt(s);
			return true;
		} catch (NumberFormatException e) {
			return false;
		}
	}

	/**
	 * test: yohanes, yoh 3:16, 3yoh 1 (?)
	 *
	 */

	static String[] getBookName(String s) {
		String [] res = new String[3];
		if (s==null || s.length()==0) return null;
		StringTokenizer st = new StringTokenizer(s, " :", false);
		int count = st.countTokens();
		if (count==0) return null;
		String []temp = new String[count];
		String chapter = "1";
		String verse = "1";

		for (int i =0 ; i < count; i++) {
			temp[i] = st.nextToken();
		}
		if (count==1) {
			res[0] = temp[0];
			res[1] = chapter;
			res[2] = verse;
			return res;
		}

		int end = count;

		if (validInteger(temp[count-1])) {
			if (count>2) {
				if (validInteger(temp[count-2])) {
					chapter = temp[count-2];
					verse = temp[count-1];
					end = count-2;
				} else {
						chapter = temp[count-1];
						end = count-1;
				}
			} else {
				chapter = temp[count-1];
				end = count-1;					
			}
		}
		String book = "";
		for (int i =0; i < end; i++) {
			if (i>0) book+=" ";
			book += temp[i];			
		}

		res[0] = book;
		res[1] = chapter;
		res[2] = verse;
		

		return res;
	}

	public static void testQuery(BiblePlusPDB bible, String s) {
		System.out.println("query: '" + s + "'");
		int [] r = bible.parseQuery(s);
		if (r==null) {
			System.out.println("not found");
			return;
		}
		BookInfo bi = bible.getBook(r[0]);		
		System.out.println(bi.getFullName() + " " + r[1] + " " + r[2]);
	}

	public static void main(String argv[]) throws IOException {
		// String [] res = getBookName("yohanes");
		// System.out.println(res[0] + "*" + res[1] + "*" + res[2]);
		// res = getBookName("yohanes 1:2");
		// System.out.println(res[0] + "*" + res[1] + "*" + res[2]);
		// res = getBookName("2 yoh 1:2");
		// System.out.println(res[0] + "*" + res[1] + "*" + res[2]);


		if (argv.length>0 && argv[0].equals("test")) {
			String b = "abc$yo%joe\n";
			String s = Util.escape(b, '%', "$\n");
			System.out.println("escape: " + s);
			System.out.println("unescape: " + Util.unescape(s, '%'));			
			System.out.println("equals: " + Util.unescape(s, '%').equals(b));			
			return;
		}


		PDBFileStream fis = new PDBFileStream("/home/yohanes/files/documents/projects/libpdbpalmbible/src/tb.pdb");
	        //PDBFileStream fis = new PDBFileStream("jskug_sjis.pdb");
		//PDBFileStream fis = new PDBFileStream("/home/yohanes/bt_pl.PDB");
		BiblePlusPDB bible = new BiblePlusPDB(fis);
		bible.loadVersionInfo();
		System.out.println(fis);
		bible.loadWordIndex();

		

		for (int b = 0; b < bible.getBookCount(); b++) {
			//for (int b = 0; b < 1; b++) {
			BookInfo book = bible.getBook(b);
			//System.out.println(book);
			book.openBook();
			//System.out.println("total verse chapter 1 : " + book.getVerseCount(1));
			
			for (int i = 1; i <= book.getChapterCount(); i++) {
				//for (int i = 1; i <= 2; i++) {
				for (int j = 1; j <= book.getVerseCount(i); j++) {
					//System.out.print(i+":"+j+" ");
					//System.out.println(book.getVerse(i,j));
					//System.out.println("\n");
				}
			}
		}
		

		/*
		BookInfo book2 = bible.getBook(42);
		book2.openBook();
		for (int i = 1; i < 10; i++) {
			System.out.println(book2.getVerse(1,i));
		}
		*/
		testQuery(bible, "yohanes");
		testQuery(bible, "yo");
		testQuery(bible, "yoh 3");
		testQuery(bible, "yoh 3:16");
		testQuery(bible, "yoh 3 16");
		testQuery(bible, "2 yoh 3 16");
		//String words[] = {"pagi", "hari"};
		//String words[] = {"Tuhan", "Allah"};
		String words[][] = 
			{
				{"firman", "Allah", "hidup"},
				{"siapa", "tidak", "berdosa"},
				{"berbahagialah", "mereka", "miskin", "hadapan", "Allah"},
				{"somevery", "complicated", "words", "whichare", "notInBible"},
				{"Allah"},
			};

		

		bible.getWordNumbers(words[0], false, true, 0);
		
		BitVector bv = new BitVector(65);
		for (int i =0; i < 65; i++) {
			bv.set(i);
		}
		System.out.println(bv);		
		bv.clear(0);
		bv.clear(1);
		bv.clear(20);
		bv.clear(64);
		System.out.println(bv);

		long _st = System.currentTimeMillis();

		Vector r = null;
		Vector r2= null;
		long _se;

		
		BookRange range = BookRanges.getRange(BookRanges.ALL_BOOKS_FROM_THIS_POINT);

		System.out.println("RANGE: " + range.getBookIndexStart() + " - " + range.getBookIndexEnd());
		
		for (int i =0 ; i < 10; i++) {
/*			
			r = bible.search(words[i%words.length], 
				       0, 1, 1,
				       //int startbook, int start_chapter, int start_verse,
				       65,
				       //int endbook, 
					true, //partial match
					true, //all words
				       10);

			_se = System.currentTimeMillis();
			
			double d = (_se-_st)/1000.0;
			
*/			
		
			_st = System.currentTimeMillis();
			//r2 = bible.textSearch(words[i%words.length], 
			r2 = bible.search(words[i%words.length], 
					      range,
					      true, //partial match
					      true, //all words
					      10);
			
			_se = System.currentTimeMillis();
			
			double d2 = (_se-_st)/1000.0;

			System.out.println((i%words.length) + " Total search time " + d2);

			
//			System.out.println((i%words.length) + " Total search time " + d + " vs " + d2);


		}


		if (r==null) {
			System.out.println("not match found");
		} else {
		

		for (int i =0; i < r.size()/3; i++) {
			int book = ((Integer)r.elementAt(i*3)).intValue();
			int chapter = ((Integer)r.elementAt(i*3+1)).intValue();
			int verse = ((Integer)r.elementAt(i*3+2)).intValue();
			System.out.println("book " + book +  "chapter " + chapter + " verse " + verse);
			BookInfo bi = bible.getBook(book);
			bi.openBook();
			System.out.println(bi.getVerse(chapter, verse));
			
		}

		}

		System.out.println("------------------------------\n");

		r = r2;
	if (r==null) return;

		for (int i =0; i < r.size()/3; i++) {
			int book = ((Integer)r.elementAt(i*3)).intValue();
			int chapter = ((Integer)r.elementAt(i*3+1)).intValue();
			int verse = ((Integer)r.elementAt(i*3+2)).intValue();
			System.out.println("book " + book +  "chapter " + chapter + " verse " + verse);
			BookInfo bi = bible.getBook(book);
			bi.openBook();
			System.out.println(bi.getVerse(chapter, verse));
			
		}


	}

}
